#!/bin/bash

work_dir=`pwd`
slurm_install_dir="${work_dir}/install"
# Manuel: changed target source dir to new repo
slurm_source_dir="${work_dir}/ces_slurm_simulator"
slurm_branch="master"

# Manuel: when cloning ces_slurm_simulator_tools a folder with ces_slurm_simulator show already be created
if [ ! -d "$slurm_source_dir" ]; then
    echo "Fatal! Clone from ces_slurm_simulator_tools was incomplete."
    exit 1
fi

# Manuel: check if the cloning was done without --recurse-module. If it wasn't then we need to init submodules
if [ -z "$(ls -A $slurm_source_dir)" ]; then
    echo "Cloning ces_slurm_simulator"
    git submodule init
    git submodule update
fi

cd $slurm_source_dir
echo "Regenerating automake Makefiles in SLURM"
#./autogen.sh > ../autogen.output.txt
autoreconf -fiv

cd $work_dir

./compile_and_install_slurm.sh "${slurm_source_dir}" "${slurm_install_dir}"
